<bugID>402118<Summary>problems when highlighting part of a title in url bar autocomplete results when the title is a RTL value</Summary><Description>problems when highlighting part of a title in url bar autocomplete results when the title is a RTL value

specifically, here's the problem:

visit a page like http://www.ynet.co.il, and then try to autocomplete on a hebrew word in the title.

because of the way the patch in bug #399664 the parts of the title will be out of order.

take the example where the title is "this is a test." and the user types "is a" in the url bar.

we'd up with:

&lt;scrollbox&gt;
&lt;label value="this "/&gt;
&lt;label style="font-weight: bold; value="is a"/&gt;
&lt;label value=" test."/&gt;
&lt;/scrollbox&gt;

looking like:  "this *is a* test."

this works for LTR, but if the title was in a RTL language, the pieces would appear out of order, looking like: " test.*is a*this "


In a previous attempt to get this working for RTL, I set the direction of the title scrollbox to match the chrome direction, which puts the labels in the right order, but they'd be out of order if the title was not in a RTL language.

It's not the chrome direction that matters, it's the direction of the text that matters.  

Note, nsTreeBodyFrame::CheckTextForBidi() has code to detect if a string has any bidi characters.

Other issues I ran into while trying to make #399664 safe for RTL titles which are still open:

1) making sure the correct ellipsis was shown 
2) ensuring the "beginning" of the title was visible.</Description></bugID>